<?php

namespace EventPortal\Domain\Component;

use EventPortal\Domain\Component\Input\Select;
use EventPortal\Domain\Component\Input\Text;
use EventPortal\Domain\Field\Models\Field;

class MakeComponent
{
    public static function fromField(Field $field): Component
    {
        if ($field->type->isSelect()) {
            return Select::make($field->name)
                ->label($field->label)
                ->options($field->data->get('options'))
                ->when($field->response, function ($select, $response): void {
                    $select->value($response->data->get('value'));
                });
        }

        return Text::make($field->name)
            ->label($field->label)
            ->when($field->response, function ($text, $response): void {
                  $text->value($response->data->get('value'));
            });
    }
}
