<?php

namespace EventPortal\Domain\Field\Resources;

use Illuminate\Http\Resources\Json\JsonResource;

class FieldResource extends JsonResource
{
    /**
     * @phpcsSuppress SlevomatCodingStandard.TypeHints.ParameterTypeHint.MissingNativeTypeHint
     * @phpcsSuppress Generic.CodeAnalysis.UnusedFunctionParameter.FoundInExtendedClass
     * @param \Illuminate\Http\Request $request
     * @return array
     */
    public function toArray($request): array
    {
        return [
            'id' => $this->id,
            'component' => $this->type,
            'name' => $this->name,
            'label' => $this->label,
            'value' => $this->when($this->response, function () {
                return $this->response->data->get('value', '');
            }),
            'options' => $this->when($this->data->get('options'), function () {
                return $this->data->get('options');
            }),
            'children' => $this->when($this->isParent(), function () {
                return FieldResource::collection($this->children);
            }),
            'placeholder' => $this->when($this->data->has('placeholder'), function () {
                return $this->data->get('placeholder');
            }),
            'clearable' => $this->when($this->data->has('clearable'), function () {
                return $this->data->get('clearable');
            }),
        ];
    }
}
