<?php

namespace EventPortal\Domain\Form\Models;

use EventPortal\Concerns\Formable;
use EventPortal\Domain\Field\Models\Field;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\Relations\MorphTo;

class Form extends Model
{
    /** @var array<string> */
    protected $with = [
        'fields',
    ];

    /** @var array<string> */
    public $guarded = [];

    public function fields(): HasMany
    {
        return $this->hasMany(Field::class);
    }

    public function formable(): MorphTo
    {
        return $this->morphTo();
    }

    public function scopeForModel(Builder $query, Formable $model): Builder
    {
        return $query
            ->where('formable_id', $model->id)
            ->where('formable_type', get_class($model));
    }
}
