<?php

namespace EventPortal\Domain\Response\Actions;

use EventPortal\Concerns\Formable;
use EventPortal\Domain\Field\Models\Field;
use EventPortal\Domain\Response\Models\Response;
use Illuminate\Support\Arr;

class RespondToForm
{
    public function execute(Formable $model, array $data): void
    {
        Field::query()
            ->forForm($model->form)
            ->onlyChildren()
            ->whereIn('name', array_keys($data))
            ->each(function ($field) use ($model, $data): void {
                $value = Arr::get($data, $field->name);

                Response::updateOrCreate(
                    [
                        'form_id' => $model->form->id,
                        'field_id' => $field->id,
                    ],
                    [
                        'form_id' => $model->form->id,
                        'field_id' => $field->id,
                        'value' => $value,
                    ]
                );
            });
    }
}
