<?php

namespace EventPortal\Tests\Unit\Component;

use EventPortal\Domain\Component\Input\Select;
use EventPortal\Domain\Component\Input\SelectOption;
use EventPortal\Tests\TestCase;

class SelectTest extends TestCase
{
    /** @test **/
    public function can_set_value()
    {
        $select = Select::make('Event type')
            ->options([
                SelectOption::make('Seminar'),
                SelectOption::make('Single'),
            ]);

        $select->value('seminar');

        $this->assertEquals('seminar', $select->value);
    }

    /** @test **/
    public function can_set_options()
    {
        $select = Select::make('Manager')
            ->options([
                SelectOption::make('Toby')->value(1),
                SelectOption::make('Andy')->value(2),
            ]);

        $expected = [
            ['label' => 'Toby', 'value' => 1],
            ['label' => 'Andy', 'value' => 2],
        ];

        $this->assertEquals($expected, $select->options);
    }
}
