<?php

namespace EventPortal\Tests\Unit\Models;

use EventPortal\Domain\Form\Models\Form;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\DatabaseMigrations;

class FormTest extends TestCase
{
    use DatabaseMigrations;

    /** @test **/
    public function can_scope_for_model()
    {
        $formA = factory(Form::class)->states('event')->create();
        $formB = factory(Form::class)->states('event')->create();

        $forms = Form::forModel($formA->formable)->get();

        $this->assertCount(1, $forms);
        $this->assertContainsModel($formA, $forms);
        $this->assertNotContainsModel($formB, $forms);
    }
}
